/********************************************************/
/*                                                      */
/*                       ELLIP.H                        */
/*  Header file for elliptical gaze-contingent windows  */
/*      Functions defined in W32_ELLIP_GCWINDOW.C       */
/*                                                      */
/*                     Version 1.0                      */ 
/*            28 August 1998 by Marc Pomplun            */
/*                                                      */
/********************************************************/


        // Use this function to initialize the window before each trial.
        // It sets size of window and offset of its center from gaze position.
        // <deadband> sets number of pixels of anti-jitter applied  

void initialize_ellip_gc_window(int wwidth, int wheight, int xoffset, int yoffset,
                                HBITMAP window_bitmap1, HBITMAP window_bitmap2,
                                HBITMAP background_bitmap1, HBITMAP background_bitmap2,
                                HWND window, RECT display_rect, int is_mask, int deadband);


        // Use this function to update GC window as soon as new gaze coordinates
        // <x, y> are available. It draws elliptical GC window at new location.
        // The first time window is drawn, 
        // the background outside the window will be filled in too.
        // If X or Y is MISSING_DATA (defined in eyelink.h), window is hidden. 
  
void redraw_ellip_gc_window(int x, int y, int window_state, int gc_eye_display);

int UpdateDisplay(int x, int y);

