/**********************************************************/
/*                                                        */
/*                    OBJ_GCWINDOW.H                      */
/*  Header file for object-based gaze-contingent windows  */
/*         Functions defined in OBJ_GCWINDOW.C            */
/*                                                        */
/*                     Version 1.0                        */ 
/*          14 September 1998 by Marc Pomplun             */
/*                                                        */
/**********************************************************/



#define OBJECT_SIZE 54

#define    ROUND_WINDOW  1
#define DISTANCE_WINDOW  2
#define   NUMBER_WINDOW  3
#define     FULL_WINDOW  4


int obj_gc_num, obj_gc_x[100], obj_gc_y[100];


        // Use this function to initialize a radius-based window before each trial.
        // It sets size of window and offset of its center from gaze position.
        // <deadband> sets number of pixels of anti-jitter applied  

void initialize_obj_rad_gcwindow(int radius, int xoffset, int yoffset,
                                 HBITMAP window_bitmap, HBITMAP background_bitmap,
                                 HWND window, RECT display_rect, int is_mask, int deadband);

        // Use this function to initialize a half-screen window before each trial.
        // It sets size of window and offset of its center from gaze position.
        // <deadband> sets number of pixels of anti-jitter applied  

void initialize_half_gcwindow(int radius, int xoffset, int yoffset,
                                 HBITMAP window_bitmap, HBITMAP background_bitmap,
                                 HWND window, RECT display_rect, int is_mask, int deadband);

        // Use this function to initialize a number-based window before each trial.
        // It sets size of window and offset of its center from gaze position.
        // <deadband> sets number of pixels of anti-jitter applied  

void initialize_obj_num_gcwindow(int number, int xoffset, int yoffset,
                                 HBITMAP window_bitmap, HBITMAP background_bitmap,
                                 HWND window, RECT display_rect, int is_mask, int deadband);

        // Use this function to update GC window as soon as new gaze coordinates
        // <x, y> are available. It draws GC window at new location.
        // The first time window is drawn, 
        // the background outside the window will be filled in too.
        // If X or Y is MISSING_DATA (defined in eyelink.h), window is hidden. 
  
void redraw_obj_gcwindow(int x, int y);
