/***********************************************/
/*                                             */
/*  VISUAL SEARCH IN GAZE-CONTINGENT DISPLAYS  */
/*                Version 1.0                  */
/*       15 August 1998 by Marc Pomplun        */
/*                                             */
/***********************************************/


#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "eyelink.h"
#include "w32_mp_exptsppt.h"
#include "w32_mp_demo.h"  /* header file for this experiment */
#include "obj_gcwindow.h"

#define  SQR(x)   ((x)*(x))



HBITMAP fgbm1=NULL, fgbm2=NULL, bgbm=NULL;
DISPLAYINFO dispinfo;

HWND full_screen_window = NULL;        // handle to our window
int full_screen_window_active = 0;     // set if window is currently active

static int window_drawn = 0;           // indicates first WM_PAINT message received
static HCURSOR arrow_cursor;           // the arrow cursor
int mouse_x, mouse_y, scene, chapter, eye_file_open = 0;


void create_image_bitmaps(char *filename_fg1, char *filename_fg2, 
													char *filename_bg)
{   
  clear_full_screen_window(RGB(255, 255, 255));
  add_file_bitmap(fgbm1, filename_fg1, 0, 0);
  add_file_bitmap(fgbm2, filename_fg2, 0, 0);
  add_file_bitmap(bgbm, filename_bg, 0, 0);
}


void new_scene(char *filename_fg1, char *filename_fg2, char *filename_bg, 
               int display_type, int window_size, char *eye_file, int eye_display, int extra)
{
  int i;
  
  create_image_bitmaps(filename_fg1, filename_fg2, filename_bg);
  i = init_display(fgbm1, fgbm2, bgbm, display_type, window_size, eye_file, eye_display, extra);
}


void end_program(void)
{
  if (fgbm1)
	  DeleteObject(fgbm1);
	if (fgbm2)
    DeleteObject(fgbm2);
	if (bgbm)
    DeleteObject(bgbm);
  SendMessage(full_screen_window, WM_CLOSE, 0, 0);
}

/*
void change_scene(void)
{
	static int max_scene[5] = {2, 10, 34, 36, 2}; 

	if (eye_file_open)
	  close_eye_file();
	if (scene == 0 && chapter == 0)
		end_program();
	if (scene == 0 || scene > max_scene[chapter])
	{
		chapter = 0;
		scene = 2;
	}
	switch (chapter)
	{
	case 0:
		switch (scene)
		{
		case 1: new_scene("title_fg.bmp", "white.bmp", "title_fg.bmp", 5, 0, "title.asc", 0, 0);
            break;
		case 2: new_scene("red.bmp", "white.bmp", "overview.bmp", 5, 30, "", 0, 0);
			      break;
		}
		break;
	case 1:
    switch (scene)
		{
		case 1: new_scene("red.bmp", "white.bmp", "text_fg.bmp", 5, 30, "", 0, 0);
			      break;
		case 2: new_scene("purple.bmp", "white.bmp", "text_fg.bmp", 5, 30, "text_no.asc", 1, 0);
			      break;
		case 3: new_scene("orange.bmp", "white.bmp", "text_fg.bmp", 5, 30, "text_no.asc", 3, 0);
			      break;
    case 4: new_scene("text_fg.bmp", "white.bmp", "text_bg.bmp", 5, 100, "", 0, 0);
			      break;
    case 5: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 100, "text_sm.asc", 1, 0);
			      break;
		case 6: new_scene("orange.bmp", "white.bmp", "text_fg.bmp", 5, 30, "text_sm.asc", 3, 0);
			      break;
    case 7: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 100, "", 0, 0);
			      break;
		case 8: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 150, "", 0, 0);
			      break;
		case 9: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 200, "", 0, 0);
			      break;
		case 10:new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 300, "", 0, 0);
			      break;
		}
		break;
	case 2:
    switch (scene)
		{
		case 1: new_scene("red.bmp", "white.bmp", "cvs_ov0.bmp", 5, 30, "", 0, 0);
			      break;
		case 2: new_scene("orange.bmp", "white.bmp", "cmm1_fg.bmp", 5, 30, "", 0, 0);
			      break;
		case 3: new_scene("purple.bmp", "white.bmp", "cmm1_fg.bmp", 5, 30, "cmm.asc", 1, 0);
			      break;
		case 4: new_scene("orange.bmp", "white.bmp", "cmm1_fg.bmp", 5, 30, "cmm.asc", 3, 0);
			      break;
		case 5: new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bgd.bmp", 5, 150, "", 0, 0);
			      break;
		case 6: new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bg.bmp", 5, 150, "", 0, 0);
			      break;
		case 7: new_scene("red.bmp", "white.bmp", "quartile.bmp", 5, 30, "", 0, 0);
			      break;
		case 8: new_scene("red.bmp", "white.bmp", "cvs_ov0.bmp", 5, 30, "", 0, 0);
			      break;
		case 9: new_scene("red.bmp", "white.bmp", "cvs_ov1.bmp", 5, 30, "", 0, 0);
			      break;
		case 10: new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bg.bmp", 5, 150, "", 0, 0);
			      break;
		case 11: new_scene("red.bmp", "white.bmp", "multi.bmp", 5, 30, "", 0, 0);
			      break;
		case 12: new_scene("red.bmp", "white.bmp", "singdual.bmp", 5, 30, "", 0, 0);
			      break;
		case 13:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bgd.bmp", 5, (int) (7.1*31.3), "", 0, 0);
			      break;
		case 14:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bgd.bmp", 5, (int) (4.1*31.3), "", 0, 0);
			      break;
                case 15: new_scene("red.bmp", "white.bmp", "tab1a.bmp", 5, 30, "", 0, 0);
			      break;
		case 16: new_scene("red.bmp", "white.bmp", "cvs_ov1.bmp", 5, 30, "", 0, 0);
			      break;
		case 17: new_scene("red.bmp", "white.bmp", "cvs_ov2.bmp", 5, 30, "", 0, 0);
			      break;
		case 18: new_scene("red.bmp", "white.bmp", "list.bmp", 5, 30, "", 0, 0);
			      break;
		case 19: new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bg.bmp", 5, 150, "", 0, 0);
			      break;
		case 20: new_scene("red.bmp", "white.bmp", "memory.bmp", 5, 30, "", 0, 0);
			      break;
		case 21:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bgd.bmp", 5, (int) (8.5*31.3), "", 0, 0);
			      break;
		case 22:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bgd.bmp", 5, (int) (6.3*31.3), "", 0, 0);
			      break;
                case 23: new_scene("red.bmp", "white.bmp", "tab1b.bmp", 5, 30, "", 0, 0);
			      break;
		case 24: new_scene("red.bmp", "white.bmp", "cvs_ov2.bmp", 5, 30, "", 0, 0);
			      break;
		case 25: new_scene("red.bmp", "white.bmp", "cvs_ov3.bmp", 5, 30, "", 0, 0);
			      break;
		case 26: new_scene("orange.bmp", "white.bmp", "cm1_fg.bmp", 5, 30, "", 0, 0);
			      break;
		case 27: new_scene("purple.bmp", "white.bmp", "cm1_fg.bmp", 5, 30, "cm.asc", 1, 0);
			      break;
		case 28: new_scene("orange.bmp", "white.bmp", "cm1_fg.bmp", 5, 30, "cm.asc", 3, 0);
			      break;
		case 29:new_scene("cm1_fg.bmp", "white.bmp", "cm1_bg.bmp", 5, 150, "", 0, 0);
			      break;
		case 30: new_scene("red.bmp", "white.bmp", "matchmis.bmp", 5, 30, "", 0, 0);
			      break;
		case 31:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bgd.bmp", 5, (int) (7.0*31.3), "", 0, 0);
			      break;
		case 32:new_scene("cm1_fg.bmp", "white.bmp", "cm1_bgd.bmp", 5, (int) (2.8*31.3), "", 0, 0);
			      break;
		case 33: new_scene("red.bmp", "white.bmp", "tab1c.bmp", 5, 30, "", 0, 0);
			      break;
		case 34: new_scene("red.bmp", "white.bmp", "cvs_ov0.bmp", 5, 30, "", 0, 0);
			      break;
		}
		break;
	case 3:
    switch (scene)
		{
		case 1: new_scene("red.bmp", "white.bmp", "suche.bmp", 5, 30, "", 0, 0);
			      break;
		case 2: new_scene("black.bmp", "white.bmp", "bars1.bmp", 5, 30, "", 0, 0);
			      break;
		case 3: new_scene("red.bmp", "white.bmp", "suche.bmp", 5, 30, "", 0, 0);
			      break;
		case 4: new_scene("black.bmp", "white.bmp", "bars1.bmp", 5, 30, "", 0, 0);
			      break;
		case 5: new_scene("purple.bmp", "white.bmp", "bars1.bmp", 5, 30, "bars1b.asc", 1, 0);
			      break;
		case 6: new_scene("black.bmp", "white.bmp", "bars1.bmp", 5, 30, "bars1b.asc", 3, 0);
			      break;
		case 7: new_scene("red.bmp", "white.bmp", "suche.bmp", 5, 30, "", 0, 0);
			      break;
		case 8: new_scene("black.bmp", "white.bmp", "bars1.bmp", 5, 30, "", 0, 0);
			      break;
		case 9: new_scene("black.bmp", "white.bmp", "bars2.bmp", 5, 30, "", 0, 0);
			      break;
		case 10: new_scene("purple.bmp", "white.bmp", "bars2.bmp", 5, 30, "bars2b.asc", 1, 0);
			      break;
		case 11: new_scene("black.bmp", "white.bmp", "bars2.bmp", 5, 30, "bars2b.asc", 3, 0);
			      break;
		case 12: new_scene("red.bmp", "white.bmp", "suche.bmp", 5, 30, "", 0, 0);
			      break;
		case 13: new_scene("black.bmp", "white.bmp", "xe.bmp", 5, 30, "", 0, 0);
			      break;
		case 14: new_scene("purple.bmp", "white.bmp", "xe.bmp", 5, 30, "xe.asc", 1, 0);
			      break;
		case 15:new_scene("black.bmp", "white.bmp", "xe.bmp", 5, 30, "xe.asc", 3, 0);
			      break;
		case 16:new_scene("orange.bmp", "white.bmp", "abs_easy.bmp", 5, 30, "", 0, 0);
			      break;
		case 17:new_scene("orange.bmp", "white.bmp", "rel_easy.bmp", 5, 30, "", 0, 0);
			      break;
		case 18:new_scene("black.bmp", "white.bmp", "xh.bmp", 5, 30, "", 0, 0);
			      break;
		case 19:new_scene("purple.bmp", "white.bmp", "xh.bmp", 5, 30, "xh.asc", 1, 0);
			      break;
		case 20:new_scene("black.bmp", "white.bmp", "xh.bmp", 5, 30, "xh.asc", 3, 0);
			      break;
    case 21:new_scene("orange.bmp", "white.bmp", "abs_hard.bmp", 5, 30, "", 0, 0);
			      break;
		case 22:new_scene("orange.bmp", "white.bmp", "rel_hard.bmp", 5, 30, "", 0, 0);
			      break;
    case 23:new_scene("black.bmp", "white.bmp", "c_fg.bmp", 5, 30, "", 0, 0);
			      break;
    case 24:new_scene("c_fg.bmp", "white.bmp", "c_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 25:new_scene("c_fg.bmp", "white.bmp", "c_bg.bmp", 5, (int) (34.8*10.0), "", 0, 0);
			      break;
		case 26:new_scene("s_fg.bmp", "white.bmp", "s_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 27:new_scene("o_fg.bmp", "white.bmp", "o_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
    case 28:new_scene("cs_fg.bmp", "white.bmp", "cs_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 29:new_scene("co_fg.bmp", "white.bmp", "co_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 30:new_scene("so_fg.bmp", "white.bmp", "so_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 31:new_scene("blue.bmp", "white.bmp", "winres1.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 32:new_scene("blue.bmp", "white.bmp", "winres2.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 33:new_scene("blue.bmp", "white.bmp", "winres3.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 34:new_scene("blue.bmp", "white.bmp", "winres4.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 35:new_scene("orange.bmp", "white.bmp", "winres7.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 36:new_scene("orange.bmp", "white.bmp", "winres8.bmp", 5, 30, "", 0, 0);
			      break;    				
		}
	  break;
	case 4: 
          	switch (scene)
		{
		case 1: new_scene("red.bmp", "white.bmp", "schluss1.bmp", 5, 30, "", 0, 0);
			      break;
		case 2: new_scene("red.bmp", "white.bmp", "schluss2.bmp", 5, 30, "", 0, 0);
			      break;
		}
		break;
	}
}

*/

void change_scene(void)
{
	static int max_scene[6] = {2, 10, 15, 21, 31, 1}; 

	if (eye_file_open)
	  close_eye_file();
	if (scene == 0 && chapter == 0)
		end_program();
	if (scene == 0 || scene > max_scene[chapter])
	{
		chapter = 0;
		scene = 2;
	}
	switch (chapter)
	{
	case 0:
		switch (scene)
		{
		case 1: new_scene("title_fg.bmp", "white.bmp", "title_bg.bmp", 5, 200, "title.asc", 2, 0);
            break;
		case 2: new_scene("red.bmp", "white.bmp", "overview.bmp", 5, 30, "", 0, 0);
			      break;
		}
		break;
	case 1:
    switch (scene)
		{
		case 1: new_scene("text_fg.bmp", "white.bmp", "white.bmp", 4, 0, "", 0, 0);
			      break;
		case 2: new_scene("purple.bmp", "white.bmp", "text_fg.bmp", 5, 30, "text_no.asc", 1, 0);
			      break;
		case 3: new_scene("purple.bmp", "white.bmp", "text_fg.bmp", 5, 0, "text_no.asc", 3, 0);
			      break;
    case 4: new_scene("text_fg.bmp", "white.bmp", "text_bg.bmp", 5, 100, "", 0, 0);
			      break;
    case 5: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 100, "text_sm.asc", 1, 0);
			      break;
		case 6: new_scene("purple.bmp", "white.bmp", "text_fg.bmp", 5, 0, "text_sm.asc", 3, 0);
			      break;
    case 7: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 100, "", 0, 0);
			      break;
		case 8: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 150, "", 0, 0);
			      break;
		case 9: new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 200, "", 0, 0);
			      break;
		case 10:new_scene("text_fg.bmp", "white.bmp", "text_bgd.bmp", 5, 300, "", 0, 0);
			      break;
		}
		break;
	case 2:
    switch (scene)
		{
		case 1: new_scene("orange.bmp", "white.bmp", "cmm1_fg.bmp", 5, 30, "", 0, 0);
			      break;
		case 2: new_scene("purple.bmp", "white.bmp", "cmm1_fg.bmp", 5, 30, "cmm.asc", 1, 0);
			      break;
		case 3: new_scene("orange.bmp", "white.bmp", "cmm1_fg.bmp", 5, 30, "cmm.asc", 3, 0);
			      break;
		case 4: new_scene("orange.bmp", "white.bmp", "cm1_fg.bmp", 5, 30, "", 0, 0);
			      break;
		case 5: new_scene("purple.bmp", "white.bmp", "cm1_fg.bmp", 5, 30, "cm.asc", 1, 0);
			      break;
		case 6: new_scene("orange.bmp", "white.bmp", "cm1_fg.bmp", 5, 30, "cm.asc", 3, 0);
			      break;
		case 7: new_scene("cm1_fg.bmp", "white.bmp", "cm1_bg.bmp", 5, 150, "", 0, 0);
			      break;
		case 8: new_scene("red.bmp", "white.bmp", "quartile.bmp", 5, 30, "", 0, 0);
			      break;
		case 9: new_scene("red.bmp", "white.bmp", "matchmis.bmp", 5, 30, "", 0, 0);
			      break;
		case 10:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bg.bmp", 5, (int) (7.0*31.3), "", 0, 0);
			      break;
		case 11:new_scene("cm1_fg.bmp", "white.bmp", "cm1_bg.bmp", 5, (int) (2.8*31.3), "", 0, 0);
			      break;
		case 12:new_scene("orange.bmp", "white.bmp", "cmm1_fg.bmp", 5, 30, "", 0, 0);
			      break;
		case 13:new_scene("red.bmp", "white.bmp", "singdual.bmp", 5, 30, "", 0, 0);
			      break;
		case 14:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bg.bmp", 5, (int) (7.0*31.3), "", 0, 0);
			      break;
		case 15:new_scene("cmm1_fg.bmp", "white.bmp", "cmm1_bg.bmp", 5, (int) (4.1*31.3), "", 0, 0);
			      break;
		}
		break;
	case 3:
    switch (scene)
		{
		case 1: new_scene("sky.bmp", "white.bmp", "white.bmp", 4, 0, "", 0, 0);
			      break;
		case 2: new_scene("sky.bmp", "sky_fg1.bmp", "red.bmp", 6, 30, "", 0, 1);
			      break;
		case 3: new_scene("sky.bmp", "white.bmp", "white.bmp", 4, 0, "", 0, 0);
			      break;
		case 4: new_scene("sky.bmp", "sky_fg2.bmp", "red.bmp", 6, 30, "", 0, 0);
			      break;
		case 5: new_scene("reg1b.bmp", "white.bmp", "red.bmp", 4, 30, "", 0, 0);
			      break;
		case 6: new_scene("reg1b.bmp", "reg1a.bmp", "red.bmp", 6, 30, "", 0, 0);
			      break;
		case 7: new_scene("red.bmp", "white.bmp", "schach2.bmp", 5, 30, "", 0, 0);
			      break;
    case 8: new_scene("reg1b.bmp", "white.bmp", "red.bmp", 4, 30, "", 0, 0);
			      break;
		case 9: new_scene("reg1b.bmp", "reg1a.bmp", "purple.bmp", 6, 30, "chess_l.asc", 1, 2);
			      break;
		case 10:new_scene("reg1b.bmp", "reg1a.bmp", "red.bmp", 4, 30, "chess_l.asc", 3, 2);
			      break;
		case 11:new_scene("reg1b.bmp", "reg1a.bmp", "purple.bmp", 6, 30, "chess_e.asc", 1, 0);
			      break;
		case 12:new_scene("reg1b.bmp", "reg1a.bmp", "red.bmp", 4, 30, "chess_e.asc", 3, 0);
			      break;
		case 13:new_scene("rand1a.bmp", "white.bmp", "red.bmp", 4, 30, "", 0, 0);
			      break;
		case 14:new_scene("rand1a.bmp", "rand1b.bmp", "red.bmp", 6, 30, "", 0, 0);
			      break;
    case 15:new_scene("rand1a.bmp", "white.bmp", "red.bmp", 4, 30, "", 0, 0);
			      break;
		case 16:new_scene("rand1a.bmp", "rand1b.bmp", "purple.bmp", 6, 30, "chess_z.asc", 1, 3);
			      break;
		case 17:new_scene("rand1a.bmp", "rand1b.bmp", "red.bmp", 4, 30, "chess_z.asc", 3, 3);
			      break;
		case 18:new_scene("reg2_fg.bmp", "reg2_eg.bmp", "reg2_bg.bmp", 7, 150, "", 0, 0);
			      break;
		case 19:new_scene("red.bmp", "white.bmp", "chessres.bmp", 5, 30, "", 0, 0);
			      break;
		case 20:new_scene("reg2_fg.bmp", "reg2_eg.bmp", "reg2_bg.bmp", 7, (int) (5.5*31.3), "", 0, 0);
			      break;
		case 21:new_scene("reg2_fg.bmp", "reg2_eg.bmp", "reg2_bg.bmp", 7, (int) (8.5*31.3), "", 0, 0);
			      break;
		}
	  break;
	case 4:
    switch (scene)
		{
		case 1: new_scene("red.bmp", "white.bmp", "suche.bmp", 5, 30, "", 0, 0);
			      break;
		case 2: new_scene("black.bmp", "white.bmp", "bars1.bmp", 5, 30, "", 0, 0);
			      break;
		case 3: new_scene("purple.bmp", "white.bmp", "bars1.bmp", 5, 30, "bars1b.asc", 1, 0);
			      break;
		case 4: new_scene("black.bmp", "white.bmp", "bars1.bmp", 5, 30, "bars1b.asc", 3, 0);
			      break;
		case 5: new_scene("black.bmp", "white.bmp", "bars2.bmp", 5, 30, "", 0, 0);
			      break;
		case 6: new_scene("purple.bmp", "white.bmp", "bars2.bmp", 5, 30, "bars2b.asc", 1, 0);
			      break;
		case 7: new_scene("black.bmp", "white.bmp", "bars2.bmp", 5, 30, "bars2b.asc", 3, 0);
			      break;
		case 8: new_scene("black.bmp", "white.bmp", "xe.bmp", 5, 30, "", 0, 0);
			      break;
		case 9: new_scene("purple.bmp", "white.bmp", "xe.bmp", 5, 30, "xe.asc", 1, 0);
			      break;
		case 10:new_scene("black.bmp", "white.bmp", "xe.bmp", 5, 30, "xe.asc", 3, 0);
			      break;
		case 11:new_scene("orange.bmp", "white.bmp", "abs_easy.bmp", 5, 30, "", 0, 0);
			      break;
		case 12:new_scene("orange.bmp", "white.bmp", "rel_easy.bmp", 5, 30, "", 0, 0);
			      break;
		case 13:new_scene("black.bmp", "white.bmp", "xh.bmp", 5, 30, "", 0, 0);
			      break;
		case 14:new_scene("purple.bmp", "white.bmp", "xh.bmp", 5, 30, "xh.asc", 1, 0);
			      break;
		case 15:new_scene("black.bmp", "white.bmp", "xh.bmp", 5, 30, "xh.asc", 3, 0);
			      break;
    case 16:new_scene("orange.bmp", "white.bmp", "abs_hard.bmp", 5, 30, "", 0, 0);
			      break;
		case 17:new_scene("orange.bmp", "white.bmp", "rel_hard.bmp", 5, 30, "", 0, 0);
			      break;
    case 18:new_scene("black.bmp", "white.bmp", "c_fg.bmp", 5, 30, "", 0, 0);
			      break;
    case 19:new_scene("c_fg.bmp", "white.bmp", "c_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 20:new_scene("c_fg.bmp", "white.bmp", "c_bg.bmp", 5, (int) (34.8*10.0), "", 0, 0);
			      break;
		case 21:new_scene("s_fg.bmp", "white.bmp", "s_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 22:new_scene("o_fg.bmp", "white.bmp", "o_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
    case 23:new_scene("cs_fg.bmp", "white.bmp", "cs_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 24:new_scene("co_fg.bmp", "white.bmp", "co_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
		case 25:new_scene("so_fg.bmp", "white.bmp", "so_bg.bmp", 5, (int) (34.8*5.0), "", 0, 0);
			      break;
	    case 26:new_scene("blue.bmp", "white.bmp", "winres1.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 27:new_scene("blue.bmp", "white.bmp", "winres2.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 28:new_scene("blue.bmp", "white.bmp", "winres5.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 29:new_scene("blue.bmp", "white.bmp", "winres6.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 30:new_scene("blue.bmp", "white.bmp", "winres3.bmp", 5, 30, "", 0, 0);
			      break;    				
		case 31:new_scene("blue.bmp", "white.bmp", "winres4.bmp", 5, 30, "", 0, 0);
			      break;    								
		}
	  break;
	case 5:
        switch (scene)
		{
		case 1: new_scene("red.bmp", "white.bmp", "schluss3.bmp", 5, 30, "", 0, 0);
			      break;
		}
		break;
	}
}



/*************** CREATE FULL-SCREEN WINDOW **********/

        // Create and draw our full-screen window 
        // This window is used for all experiment graphics

LRESULT CALLBACK full_screen_window_proc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
  WNDCLASS wc;   // the window class definition
  UINT32 t;      // timer variable
  MSG msg;
  int last_call, now;

  arrow_cursor = LoadCursor( NULL, IDC_ARROW );        // load the default cursor

                              // set up and register window class 
  wc.style = CS_HREDRAW | CS_VREDRAW ;                 // force redraw if redisplaying
  wc.lpfnWndProc = (WNDPROC)full_screen_window_proc;   // the window message processing function
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;                            // our application instance
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);      // our icon
  wc.hCursor = arrow_cursor;                           // the default cursor
  wc.hbrBackground = NULL;                             // let the message handler clear background
  wc.lpszMenuName = NULL;                              // no menu
  wc.lpszClassName = "Fullscreen";                     // the identifier for this window type

  RegisterClass(&wc);           // Create the class
                              
  full_screen_window =          // Create the window
      CreateWindowEx(WS_EX_APPWINDOW,                // We want to see it in desktop bar
                     "Fullscreen",                   // Class of window 
                     "Eyelink Demo Application",     // and name of application
                     WS_POPUP,                       // DON'T use WS_MAXIMIZE, it repaints twice!
                     0, 0,  
                     GetSystemMetrics(SM_CXSCREEN),  // Set initial size to maximize,
                     GetSystemMetrics(SM_CYSCREEN),  // otherwise repaint can trash graphics
                     NULL, NULL, hInstance, NULL );  // our application instance

  if(!full_screen_window) return -1;       // exit if failed to create

  window_drawn = 0;                                   
  ShowWindow(full_screen_window, SW_SHOW);   // draw the window
  UpdateWindow(full_screen_window);
  SCREEN_LEFT = 0;
	SCREEN_TOP = 0;
	SCREEN_RIGHT = GetSystemMetrics(SM_CXSCREEN);
  SCREEN_BOTTOM = GetSystemMetrics(SM_CYSCREEN);
  SCRWIDTH = GetSystemMetrics(SM_CXSCREEN);
  SCRHEIGHT = GetSystemMetrics(SM_CYSCREEN);
	scene = 1;
	chapter = 0;
	last_call = 0;
  fgbm1 = blank_bitmap(RGB(255, 255, 255));
  fgbm2 = blank_bitmap(RGB(255, 255, 255));
  bgbm = blank_bitmap(RGB(255, 255, 255));
  change_scene();
  
	while (TRUE)
  {
    if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
      if (msg.message == WM_QUIT)
        break;
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
    now = GetTickCount();
    if (now - last_call >= 1)
    {
      last_call = now;			
			UpdateDisplay(mouse_x, mouse_y);
		}
  }
  return msg.wParam ;
}


          // Ensure the window is closed before exiting
void close_full_screen_window(void)
{

  if(full_screen_window)           // if window is still open:
    {
      DestroyWindow(full_screen_window);  // close window
      full_screen_window = NULL;          // mark window as deleted
    }
}


        // Clear the window background to a color
void clear_full_screen_window(COLORREF color)
{
  RECT rc;   
  HDC hdc;  
  HBRUSH oBrush;

  if(!full_screen_window) return;           // make sure window is still open!
  hdc = GetDC(full_screen_window);          // get drawing context
  GetWindowRect(full_screen_window, &rc);   // get window size

  oBrush = SelectObject(hdc, CreateSolidBrush(color|0x02000000L));  // brush to fill with 
  PatBlt(hdc, rc.left, rc.top, 
         rc.right-rc.left+1, rc.bottom-rc.top+1, PATCOPY);  // Fill window plus frame area

  DeleteObject(SelectObject(hdc, oBrush));  // Clean up GDI resources
  ReleaseDC(full_screen_window, hdc);
}


LRESULT CALLBACK full_screen_window_proc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{                     
  PAINTSTRUCT ps;
  static int y[6] = {50, 150, 245, 390, 530, 590};
	int timecheck;
	HDC hdc;
  HBRUSH hbrush;
	HPEN hpen;

  if(hwnd==NULL) return FALSE;  // could happen if full_screen_window already closed

  switch (message)
    {
      
      case WM_ACTIVATE:         // Window is activated or deactivated
        full_screen_window_active = LOWORD(wparam) != WA_INACTIVE;
        if(full_screen_window_active)
          {                     // newly active: make sure it's fully visible
            ShowWindow(full_screen_window, SW_SHOWMAXIMIZED );
            UpdateWindow(full_screen_window);
          }
        break;

      case WM_CLOSE:      // If ALT-F4 pressed, force program to close 
        PostQuitMessage(0);
        break;

      case WM_DESTROY:     // Window being closed by ALT-F4
         PostQuitMessage(0);
         full_screen_window = NULL;  // mark window as deleted
        break;

      case WM_QUIT:        // Need to break out of any loops
        break;

      case WM_SETCURSOR:   // Cursor moving into window area
	      if(full_screen_window_active) 
          SetCursor(NULL);          // If covering full screen, hide it
        else 
          SetCursor(arrow_cursor);  // Otherwise, keep cursor visible
	      return TRUE;

			case WM_MOUSEMOVE:
				mouse_x = LOWORD(lparam);
				mouse_y = HIWORD(lparam);
				return 0;

      case WM_LBUTTONDOWN:
				if (scene == 2 && chapter == 0)
				{
					if (mouse_y < 160)
						chapter = 1;
					else if (mouse_y < 300)
						chapter = 2;
					else if (mouse_y < 400)
						chapter = 3;
					else if (mouse_y < 500)
						chapter = 4;
					else
						chapter = 5;
					scene = 1;
          hdc = GetDC(full_screen_window);
					hbrush = GetStockObject(WHITE_BRUSH);
					hpen = GetStockObject(WHITE_PEN);
					SelectObject(hdc, hbrush);
					SelectObject(hdc, hpen);
					Rectangle(hdc, 0, 0, 799, y[chapter - 1]);
					Rectangle(hdc, 0, y[chapter], 799, 599);
					ReleaseDC(full_screen_window, hdc);
					timecheck = GetTickCount();
					while (GetTickCount() < timecheck + 1000);
				}
				else
				  scene++;
				change_scene();
				return TRUE;
      
			case WM_RBUTTONDOWN:
				scene--;
				change_scene();
				return TRUE;

      case WM_PAINT:                // Redraw window (after parts are unobscured by other windows)
        {                           // Only happens after dialog boxes erased, or ALT-TAB
          HDC hdc = BeginPaint(hwnd, &ps);
          HBRUSH oBrush;
                                     // create a brush to fill with 
          oBrush = SelectObject(hdc, CreateSolidBrush(RGB(255, 255, 255)|0x02000000L));
          PatBlt(hdc, ps.rcPaint.left, ps.rcPaint.top,     // Fill window plus frame area
                      ps.rcPaint.right-ps.rcPaint.left+1, 
                      ps.rcPaint.bottom-ps.rcPaint.top+1, PATCOPY); 
          DeleteObject(SelectObject(hdc, oBrush));         // Clean up GDI resources
          window_drawn ++;          // mark window as drawn the first time
          EndPaint(hwnd, &ps);    
          return TRUE;
        }

      case WM_ERASEBKGND:  
        return TRUE;     // don't clear background, let WM_PAINT handle it           
         
    }                               // Let Windows handle all other messages
  return DefWindowProc(hwnd, message, wparam, lparam);
}

